<template>
  <div id="app">
    <div class="d-flex flex-space-bettwen px-5">
      <span class="app-title">Check List</span>
      <v-spacer />
      <v-btn
        @click="showModal()"
        :disabled="selected === null"
        small
        color="primary"
      >
        <v-icon>mdi-pencil</v-icon> Edit</v-btn
      >
    </div>
    <v-card class="mx-3 mt-5 px-2 w-100">
      <v-row>
        <v-col cols="12" class="pb-0">
          <div>
            <v-data-table
              :headers="headers"
              :items="dataResponse"
              :items-per-page="5"
              :search="search"
              class="elevation-1"
              show-select
              v-model="selected"
            >
              <template v-slot:item.action="{ item }">
                <v-btn icon @click="showModalDelete(item.id)" color="#e21717"
                  ><v-icon>mdi-delete</v-icon></v-btn
                >
              </template>
            </v-data-table>
          </div>
        </v-col>
      </v-row>
    </v-card>
    <!-- modal -->
    <v-dialog v-model="dialog" persistent>
      <v-card class="pa-3">
        <v-card-title class="text-blood pl-3 pt-1 pr-0 pb-3"
          >Edit Data
          <v-spacer></v-spacer>
          <v-icon class="float-right" @click.prevent="dialog = false"
            >mdi-close</v-icon
          >
        </v-card-title>
        <div class="border-top ma-3 pt-5">
          <ValidationObserver ref="form" v-slot="{ handleSubmit }">
            <v-form @submit.prevent="handleSubmit(submitForm)">
              <div v-for="(item, index) in selected" :key="index.id">
                <v-row>
                  <v-col cols="4" class="pb-0">
                    <p class="app-title-small text-sm ma-0">
                      Name
                    </p>
                    <ValidationProvider
                      v-slot="{ errors }"
                      name="Name"
                      rules="required"
                    >
                      <v-text-field
                        v-model="name[index]"
                        :error-messages="errors"
                        single-line
                        dense
                        outlined
                      ></v-text-field>
                    </ValidationProvider>
                  </v-col>
                  <v-col cols="4" class="pb-0">
                    <p class="app-title-small text-sm ma-0">
                      Email
                    </p>
                    <ValidationProvider
                      v-slot="{ errors }"
                      name="Email"
                      rules="required|email"
                    >
                      <v-text-field
                        v-model="email[index]"
                        :error-messages="errors"
                        single-line
                        dense
                        outlined
                      ></v-text-field>
                    </ValidationProvider>
                  </v-col>
                  <v-col cols="4" class="pb-0">
                    <p class="app-title-small text-sm ma-0">
                      Amount
                    </p>
                    <ValidationProvider
                      v-slot="{ errors }"
                      name="Amount"
                      rules="required"
                    >
                      <v-text-field
                        v-model="amount[index]"
                        :error-messages="errors"
                        single-line
                        dense
                        outlined
                      ></v-text-field>
                    </ValidationProvider>
                  </v-col>
                </v-row>
              </div>
              <v-card-actions
                ><v-btn
                  type="submit"
                  color="#19abab"
                  class="text-center mt-3 border-top"
                  block
                  dark
                  small
                >
                  <span class="text-capitalize">Update</span>
                </v-btn>
              </v-card-actions>
            </v-form>
          </ValidationObserver>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { createNamespacedHelpers } from "vuex";
const { mapState } = createNamespacedHelpers("master");
export default {
  name: "master",
  components: {},
  data() {
    return {
      dialog: false,
      dialog2: false,
      loading: false,
      search: null,
      name: [],
      email: [],
      amount: [],
      editCondition: false,
      actionType: null,
      deleteDialog: false,
      loadingDel: false,
      temp_id: null,
      label: null,
      selected: null,
      headers: [
        { text: "Name", value: "name" },
        { text: "Email", value: "email" },
        { text: "Amount Count", value: "amount" },
        { text: "", value: "action" }
      ]
    };
  },
  watch: {},
  mounted() {
    this.$store.dispatch("master/getData");
  },
  computed: {
    ...mapState(["dataResponse"])
  },
  methods: {
    closeSuccessNavigate() {
      setTimeout(() => {
        this.$router.go();
      }, 200);
    },
    showModal() {
      this.selected.forEach(item => {
        console.log(item);
        this.name.push(item.name);
        this.email.push(item.email);
        this.amount.push(item.amount);
      });
      console.log(name);
      this.dialog = true;
    }
  }
};
</script>
